sound_fds:
	lda	channel_sel
	asl	a
	tax
	dec	sound_counter,x
	bne	return200
	jsr	sound_fds_read
	lda	rest_flag,x
	and	#%00000001
	cmp	#%00000001
	beq	return199
fds_softenve_write:
	lda	effect_flag,x
	and	#%00000001
	cmp	#%00000001
	bne	fds_lfo_write
	jsr	sound_fds_softenve

fds_lfo_write:
	lda	effect_flag,x
	and	#%00010000
	cmp	#%00010000
	bne	fds_pitch_enve_write
	jsr	sound_fds_lfo

fds_pitch_enve_write:
	lda	effect_flag,x
	and	#%00000010
	cmp	#%00000010
	bne	fds_note_enve_write
	jsr	sound_fds_pitch_enve

fds_note_enve_write:
	lda	effect_flag,x
	and	#%00001000
	cmp	#%00001000
	bne	fds_hard_enve_write
	jsr	sound_fds_note_enve

fds_hard_enve_write:
	lda	effect_flag,x
	and	#%00000100
	cmp	#%00000100
	bne	fds_freq_write
	jsr	sound_fds_hard_enve

fds_freq_write:
	jsr	sound_fds_write
return199
	rts
return200
	lda	rest_flag,x
	and	#%00000001
	cmp	#%00000001
	beq	return201
fds_softenve_write2:
	lda	effect_flag,x
	and	#%00000001
	cmp	#%00000001
	bne	fds_lfo_write_2
	jsr	sound_fds_softenve
fds_lfo_write_2:
	lda	effect_flag,x
	and	#%00010000
	cmp	#%00010000
	bne	fds_pitch_enve_write_2
	jsr	sound_fds_lfo

fds_pitch_enve_write_2:
	lda	effect_flag,x
	and	#%00000010
	cmp	#%00000010
	bne	fds_note_enve_write_2
	jsr	sound_fds_pitch_enve

fds_note_enve_write_2:
	lda	effect_flag,x
	and	#%00001000
	cmp	#%00001000
	bne	fds_hard_enve_write_2
	jsr	sound_fds_note_enve

fds_hard_enve_write_2:
	lda	effect_flag,x
	and	#%00000100
	cmp	#%00000100
	bne	return201
	jsr	sound_fds_hard_enve

return201:
	rts
;------------------------------------------------
fds_freq_set:
	lda	channel_sel
	asl	a
	tax
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a
	tay

	lda	fds_frequency_table,y	;PSGge[uLowǂݏo
	sta	sound_freq_low,x	;
	iny				;yP₵
	lda	fds_frequency_table,y	;PSGge[uHighǂݏo
	sta	sound_freq_high,x	;

fds_oct_set1:

	lda	sound_sel,x		;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;
	cmp	#$06
	beq	fds_freq_end		;[Ȃ炻̂܂܏I
	tay

fds_oct_set2:

	lsr	sound_freq_high,x	;EVtg@C
	ror	sound_freq_low,x	;C玝Ăł@E[eCg
	iny				;
	cpy	#$06
	bne	fds_oct_set2		;IN^[uJԂ

fds_freq_end:
	rts
;---------------------------------------------------------------
sound_fds_read:
	jsr	reg400x
	lda	[sound_add_low,x]
;----------
;f[^Ghݒ
	cmp	#$ff
	bne	fds_wave_set

	lda	loop_point_table,x
	sta	<sound_add_low,x
	inx
	lda	loop_point_table,x
	sta	<sound_add_low,x
	jmp	sound_fds_read
;----------
;Fݒ
fds_wave_set:
	cmp	#$fe
	bne	fds_volume_set
	jsr	sound_data_address
	lda	[sound_add_low,x]

	asl	a
	tax
	lda	fds_data_table,x
	sta	<fds_wave_address
	inx
	lda	fds_data_table,x
	sta	<fds_wave_addhigh

	ldy	#$00
	ldx	#$00
	lda	#$80
	sta	$4089
wave_data_set:
	lda	[fds_wave_address],y
	sta	$4040,y
	iny
	cpy	#$40
	bne	wave_data_set

	lda	#$00
	sta	$4089
	jsr	reg400x
	jsr	sound_data_address
	jmp	sound_fds_read
;----------
;ʐݒ
fds_volume_set:
	cmp	#$fd
	bne	fds_rest_set
	jsr	sound_data_address
	lda	[sound_add_low,x]

	pha
	and	#%11000000		;bit7,6
	cmp	#%11000000
	beq	fds_softenve_part	;\tgGx

fds_volume_part:
	lda	effect_flag,x
	and	#%11111110
	sta	effect_flag,x		;\tgGxw

	pla
	sta	fds_volume
	sta	$4080			;{[n[hGx
	jsr	sound_data_address
	jmp	sound_fds_read

fds_softenve_part:
	lda	effect_flag,x
	ora	#%00000001
	sta	effect_flag,x		;\tgGxLw

	pla
	and	#%00111111
	sta	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y	;\tgGxf[^AhXݒ
	sta	<soft_add_low,x
	iny
	lda	softenve_table,y
	sta	<soft_add_high,x
	jsr	sound_data_address
	jmp	sound_fds_read
;;----------
;T=1
;F=i\tgGxtOɂAUS܂Łj
;ffffff=_CNgl or ڂH;
;
;T=0
;F=in/out
;ffffff1=Xs[h;
;
;$408a - (Write) Hard Enverope Flag
;bit E-------
;	E: Enverope Set 0:Disable 1:Fade-in/-out Enable
;
;----------
fds_rest_set:
	cmp	#$fc
	bne	fds_lfo_set

	lda	rest_flag,x
	ora	#%00000001
	sta	rest_flag,x

	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x

	lda	#$00
	sta	$4080
	jsr	sound_data_address
	rts
;----------
fds_lfo_set:
	cmp	#$fb
	bne	fds_detune_set

	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	fds_lfo_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%10001111		;LFO
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_fds_read

fds_lfo_data_set:
	asl	a
	asl	a
	tay

	lda	channel_sel
	asl	a
	tax

	lda	lfo_data,y
	sta	lfo_st_counter_1,x
	sta	lfo_st_counter_2,x	;LFOJn܂ł̃JE^Zbg
	iny
	lda	lfo_data,y
	sta	lfo_move,x		;LFOœʃZbg
	iny
	lda	lfo_data,y
	sta	lfo_revers,x		;g`]܂ł̓񐔃Zbg
	inc	lfo_revers,x
	iny
	lda	effect_flag,x
	and	#%10001111
	ora	#%00010000		;LFOLtOZbg
	ora	lfo_data,y		;LFOJntOZbg
	sta	effect_flag,x

	jsr	sound_data_address
	jmp	sound_fds_read
;----------
fds_detune_set:
	cmp	#$fa
	bne	fds_pitch_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	fds_detune_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%01111111		;detune
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_fds_read

fds_detune_data_set:
	pha
	jsr	reg400x
	pla
	tay
	sta	detune_dat,x
	lda	effect_flag,x
	ora	#%10000000		;detuneL
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_fds_read

;----------
;sb`Gx[vݒ
fds_pitch_set:
	cmp	#$f8
	bne	fds_arpeggio_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	fds_pitch_enve_part

	lda	effect_flag,x
	and	#%11111101
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_fds_read

fds_pitch_enve_part:
	sta	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_table,y
	sta	<pitch_add_high,x

	lda	effect_flag,x
	ora	#%00000010
	sta	effect_flag,x

	jsr	sound_data_address
	jmp	sound_fds_read

;----------
;m[gGx[vݒ
fds_arpeggio_set:
	cmp	#$f7
	bne	fds_freq_direct_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	fds_arpeggio_part

	lda	effect_flag,x
	and	#%11110111
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_fds_read

fds_arpeggio_part:
	sta	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_table,y
	sta	<arpe_add_high,x

	lda	effect_flag,x
	ora	#%00001000
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_fds_read
;----------
;Đgڐݒ
fds_freq_direct_set:
	cmp	#$f6
	bne	fds_y_command_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_freq_low,x		;Low
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_freq_high,x		;High
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x			;Counter
	jsr	sound_data_address
	rts
;----------
;R}hݒ
fds_y_command_set:
	cmp	#$f5
	bne	fds_wait_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<reg_add_low
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<reg_add_high
	jsr	sound_data_address
	lda	[sound_add_low,x]
	ldx	#$00
	sta	[reg_add_low,x]
	jsr	reg400x
	jsr	sound_data_address
	jmp	sound_fds_read
;----------
;EFCgݒ
fds_wait_set:
	cmp	#$f4
	bne	fds_hard_lfo_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x
	jsr	sound_data_address
	rts

;----------
;FDSn[hEFAGtFNgݒ
fds_hard_lfo_set:
	cmp	#$f3
	bne	fds_oto_set

	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	fds_hard_lfo_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%11111011
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_fds_read
fds_hard_lfo_data_set:
	asl	a
	asl	a
	asl	a
	asl	a
	tay

	sta	fds_hard_select
	inc	fds_hard_select
	lda	fds_effect_select,y
	sta	fds_hard_count_1
	sta	fds_hard_count_2
	jsr	reg400x
	lda	effect_flag,x
	ora	#%00000100
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_fds_read
;----------
fds_oto_set:
	sta	sound_sel,x		;͂܂
	jsr	sound_data_address
	lda	[sound_add_low,x]	;ǂݏo
	sta	sound_counter,x		;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	lda	#$00
	sta	$4083
	sta	rest_flag,x
	jsr	fds_freq_set		;gZbg
	lda	fds_volume
	sta	$4080
	jsr	fds_effect_init
	rts
;-------------------------------------------------------------------------------
sound_fds_write:
	jsr	reg400x
fds_write:
	lda	sound_freq_low,x	;Low Write
	sta	$4082
	lda	sound_freq_high,x	;High Write
	sta	$4083
	rts
;-------------------------------------------------------------------------------

sound_fds_softenve:
	jsr	reg400x
	lda	[soft_add_low,x]
	cmp	#$ff
	beq	return223

	and	#%00111111
	ora	#$80
	sta	$4080
	jsr	enverope_address
	rts
return223:
	lda	softenve_sel,x
	asl	a
	tay
	lda	softenve_lp_table,y
	sta	<soft_add_low,x
	iny
	lda	softenve_lp_table,y
	sta	<soft_add_high,x
	jmp	sound_fds_softenve
;-------------------------------------------------------------------------------
sound_fds_lfo:
	jsr	reg400x
	dec	lfo_st_counter_2,x
	bne	fds_lfo_end

	inc	lfo_st_counter_2,x

	lda	lfo_counter,x
	cmp	lfo_revers,x
	bne	fds_tsuduki		;@@ALFOύXJE^ >= g`]܂ł̓񐔁@ȂA

	lda	#$00
	sta	lfo_counter,x		;@@@@LFOύXJE^ = - g`]܂ł̓
	lda	effect_flag,x
	and	#%00100000
	cmp	#%00100000
	beq	fds_jousyou		;@@@@ALFOtO = ~ȂA

fds_kakou:
	lda	effect_flag,x
	adc	#$20
	sta	effect_flag,x		;@@@@@@LFOtO = ~
	jmp	fds_tsuduki

fds_jousyou:
	lda	effect_flag,x		;@@@@łȂȂiLFOtO = ~jȂA
	sbc	#$20
	sta	effect_flag,x		;@@@@@@LFOtO = ㏸


fds_tsuduki:
	lda	effect_flag,x		;   LFOtO = ~ Ȃ
	and	#%00100000
	cmp	#%00100000
	beq	fds_MINUS
					;ݐϒl = ݐϒl + P񂲂Ƃɑl
					;݂̒l = Kigj + ݐϒl
					;݂̒l = Kigj + (ݐϒl >> 4)
fds_PLUS:
	clc
	lda	sound_freq_low,x
	adc	lfo_move,x
	bcs	fds_freq_high_plus2
	sta	sound_freq_low,x	;    ݂̒l = ݂̒l - œl
	jmp	fds_tsuduki2
fds_freq_high_plus2:
	sta	sound_freq_low,x
	inc	sound_freq_high,x
	jmp	fds_tsuduki2

fds_MINUS:
	sec
	lda	sound_freq_low,x	;  łȂȂiLFOtO = ㏸łȂj
	sbc	lfo_move,x
	bcc	fds_freq_high_minus2
	sta	sound_freq_low,x	;    ݂̒l = ݂̒l + œl
	jmp	fds_tsuduki2
fds_freq_high_minus2:
	sta	sound_freq_low,x
	dec	sound_freq_high,x
					;܂ŁB
fds_tsuduki2:
	inc	lfo_counter,x		;	@@LFOύXJE^ = LFOύXJE^ + 1
	jsr	reg400x
	lda	sound_freq_low,x
	sta	$4082			;@@ݒlWX^ɃZbg
	lda	sound_freq_high,x
	sta	$4083
fds_lfo_end:
	rts				;܂
;-------------------------------------------------------------------------------
sound_fds_pitch_enve:
	jsr	reg400x			;XYreg𐮂
	lda	[pitch_add_low,x]	;sb`f[^ǂݏo
	cmp	#$ff			;I肩H
	beq	return262		;IĂ჋[v

	and	#%10000000		;{|f
	cmp	#%10000000		;bit7mF
	beq	fds_pitch_plus		;bit7Ă΃}CiX

	lda	[pitch_add_low,x]	;phaplaőpĂǂ
	clc				;vẐ߃L[tONA
	adc	sound_freq_low,x	;Pɑ
	bcs	fds_freq_high_plus	;I[o[t[Ȃhigh{P
	sta	sound_freq_low,x	;low
	jmp	fds_pitch_write		;WX^݂GO!
fds_freq_high_plus:
	sta	sound_freq_low,x	;low
	inc	sound_freq_high,x	;high{P
	jmp	fds_pitch_write		;WX^݂GO!

fds_pitch_plus:				;zg̓}CiX
	lda	[pitch_add_low,x]	;sb`f[^ǂ݂
	and	#%01111111		;bit7
	sta	temporary		;e|ɕۑ
	sec				;L[tOZbg
	lda	sound_freq_low,x	;݂̒lǂݏo
	sbc	temporary		;sb`f[^}CiXvZ

	bcc	fds_freq_high_minus	;ʂĂ猅
	sta	sound_freq_low,x
	jmp	fds_pitch_write

fds_freq_high_minus:
	sta	sound_freq_low,x
	dec	sound_freq_high,x

fds_pitch_write:
	clv
	lda	sound_freq_low,x
	sta	$4082
	lda	sound_freq_high,x
	sta	$4083
	jsr	pitch_enverope_address
	rts

return262:
	lda	[pitch_add_low,x]
	lda	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_lp_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_lp_table,y
	sta	<pitch_add_high,x
	jmp	sound_fds_pitch_enve
;-------------------------------------------------------------------------------
sound_fds_note_enve
	jsr	reg400x
	lda	[arpe_add_low,x]	;m[gGxf[^ǂݏo
	cmp	#$ff			;$ffiIjH
	bne	fds_tsuduki99		;łȂΑ
	jmp	fds_return82		;$ffȂ烋[v|Cg֖߂

fds_tsuduki99
	cmp	$00			;[H
	beq	fds_note_freq_write	;[Ȃ牽I
	cmp	$80
	beq	fds_note_freq_write	;[Ȃ牽I
	and	#%10000000
	cmp	#%10000000		;|H
	beq	fds_arpeggio_minus	;|

fds_arpeggio_plus:
	lda	[arpe_add_low,x]	;m[gGxf[^ǂݏo
	sta	arpeggio_tmp		;e|ɒui[v񐔁j
fds_arpeggio_plus2:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$0f			;4bito
	cmp	#$0b			;bȂ
	beq	fds_oct_plus		;IN^[u{
	inc	sound_sel,x		;łȂΉK{P
	jmp	fds_loop_1		;[vP
fds_oct_plus:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$f0			;4bito4bit[
	clc
	adc	#$10			;IN^[u{P
	sta	sound_sel,x		;Kf[^o
fds_loop_1:
	dec	arpeggio_tmp		;[v񐔁|P
	lda	arpeggio_tmp		;œǂݏo
	cmp	#$00			;[H
	beq	fds_note_freq_set	;Ȃ烋[vI
	jmp	fds_arpeggio_plus2	;łȂ΂܂

fds_arpeggio_minus:
	lda	[arpe_add_low,x]
	and	#%01111111
	sta	arpeggio_tmp
fds_arpeggio_minus2:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$0f			;4bito
	cmp	#$00			;[H
	beq	fds_oct_minus		;[Ȃ|
	dec	sound_sel,x		;łȂΉK|P
	jmp	fds_loop_2		;[vQ
fds_oct_minus:
	lda	sound_sel,x		;Kf[^ǂݏo
	clc
	adc	#$0b			;+b
	sec
	sbc	#$10			;-10
	sta	sound_sel,x		;Kf[^o
fds_loop_2:
	dec	arpeggio_tmp		;[v񐔁|P
	lda	arpeggio_tmp		;œǂݏo
	cmp	#$00			;[H
	beq	fds_note_freq_set	;Ȃ烋[vI
	jmp	fds_arpeggio_minus2	;łȂ΂܂

fds_note_freq_set:
	jsr	fds_freq_set
fds_note_freq_write:
	jsr	reg400x
	lda	sound_freq_low,x
	sta	$4082
	lda	sound_freq_high,x
	sta	$4083
	jsr	arpeggio_address
	rts

fds_return82:
	lda	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_lp_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_lp_table,y
	sta	<arpe_add_high,x
	jmp	sound_fds_note_enve
;-------------------------------------------------------------------------------
sound_fds_hard_enve:

	lda	fds_hard_count_1
	cmp	#$00
	beq	start_effect
	cmp	#$ff
	beq	return6809
	dec	fds_hard_count_1
return6809:
	rts
start_effect:
	lda	fds_hard_select
	tax
start_effect_2:
	lda	fds_effect_select,x
	tay
	inx
	cmp	#$ff
	beq	count_effect
	cmp	#$88
	beq	set_4088
	lda	fds_effect_select,x
	sta	$4000,y
	inx
	jmp	start_effect_2

count_effect:
	dec	fds_hard_count_1
	rts
set_4088:
	lda	fds_effect_select,x
	stx	temporary

	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	tay
	ldx	#$00
fds_4088_write:
	lda	fds_4088_data,y
	sta	$4088
	iny
	inx
	cpx	#$20
	beq	oshimai
	jmp	fds_4088_write
oshimai:
	ldx	temporary
	inx
	jmp	start_effect_2
;-------------------------------------------------------------------------------
fds_effect_init:
;\tgEFAGx[vǂݍ݃AhX
	lda	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y
	sta	<soft_add_low,x
	iny
	lda	softenve_table,y
	sta	<soft_add_high,x

;sb`Gx[vǂݍ݃AhX
	lda	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_table,y
	sta	<pitch_add_high,x

;hard enveope init

	lda	fds_hard_count_2
	sta	fds_hard_count_1
	lda	#$00
	sta	$4084
	sta	$4085
	sta	$4086
	sta	$4087

;m[gGx[vǂݍ݃AhX
	lda	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_table,y
	sta	<arpe_add_high,x
;\tgEFALFO
	lda	lfo_st_counter_1,x	;LFOJnJE^Zbg
	sta	lfo_st_counter_2,x

	lda	effect_flag,x		;LFOJnZbg
	and	#%11011111
	sta	effect_flag,x
	and	#%01000000
	lsr	a
	ora	effect_flag,x
	sta	effect_flag,x
	lda	lfo_revers,x
	lsr	a
	sta	lfo_counter,x		;LFOύXJE^Zbg

;xtONA
	lda	#$00
	sta	rest_flag,x

	jsr	reg400x
	rts
;-------------------------------------------------------------------------------
