sound_n106:
	lda	channel_sel
	asl	a
	tax
	dec	sound_counter,x
	bne	return2000
	jsr	sound_n106_read
	lda	rest_flag,x
	and	#%00000001
	cmp	#%00000001
	beq	return1990
n106_softenve_write:
	lda	effect_flag,x
	and	#%00000001
	cmp	#%00000001
	bne	n106_lfo_write
	jsr	sound_n106_softenve

n106_lfo_write:
	lda	effect_flag,x
	and	#%00010000
	cmp	#%00010000
	bne	n106_pitch_enve_write
	jsr	sound_n106_lfo

n106_pitch_enve_write:
	lda	effect_flag,x
	and	#%00000010
	cmp	#%00000010
	bne	n106_note_enve_write
	jsr	sound_n106_pitch_enve

n106_note_enve_write:
	lda	effect_flag,x
	and	#%00001000
	cmp	#%00001000
	bne	n106_hard_enve_write
	jsr	sound_n106_note_enve

n106_hard_enve_write:
	lda	effect_flag,x
	and	#%00000100
	cmp	#%00000100
	bne	n106_freq_write
	jsr	sound_n106_hard_enve

n106_freq_write:
	jsr	sound_n106_write
return1990
	rts
return2000
	lda	rest_flag,x
	and	#%00000001
	cmp	#%00000001
	beq	return2010
n106_softenve_write2:
	lda	effect_flag,x
	and	#%00000001
	cmp	#%00000001
	bne	n106_lfo_write_2
	jsr	sound_n106_softenve
n106_lfo_write_2:
	lda	effect_flag,x
	and	#%00010000
	cmp	#%00010000
	bne	n106_pitch_enve_write_2
	jsr	sound_n106_lfo

n106_pitch_enve_write_2:
	lda	effect_flag,x
	and	#%00000010
	cmp	#%00000010
	bne	n106_note_enve_write_2
	jsr	sound_n106_pitch_enve

n106_note_enve_write_2:
	lda	effect_flag,x
	and	#%00001000
	cmp	#%00001000
	bne	n106_hard_enve_write_2
	jsr	sound_n106_note_enve

n106_hard_enve_write_2:
	lda	effect_flag,x
	and	#%00000100
	cmp	#%00000100
	bne	return2010
	jsr	sound_n106_hard_enve

return2010:
	rts
;------------------------------------------------
n106_freq_set:
	lda	channel_sel
	asl	a
	tax
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a
	asl	a
	tay

	lda	n106_frequency_table,y	;n106ge[uLowǂݏo
	sta	sound_freq_low,x	;
	iny				;yP₵
	lda	n106_frequency_table,y	;n106ge[uMidleǂݏo
	sta	sound_freq_mid,x	;
	iny				;yP₵
	lda	n106_frequency_table,y	;n106ge[uHighǂݏo
	sta	sound_freq_high,x	;

n106_oct_set1:

	lda	sound_sel,x		;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;
	cmp	#$08
	beq	n106_freq_end		;[Ȃ炻̂܂܏I
	tay

n106_oct_set2:

	lsr	sound_freq_high,x	;EVtg@C
	ror	sound_freq_mid,x	;C玝Ăł@E[eCg
	ror	sound_freq_low,x	;C玝Ăł@E[eCg
	iny				;
	cpy	#$08
	bne	n106_oct_set2		;IN^[uJԂ

n106_freq_end:

	lda	effect_flag,x
	and	#%10000000
	cmp	#%10000000
	beq	n106_detune_part
	rts

n106_detune_part:
	lda	detune_dat,x
	and	#%10000000
	cmp	#%10000000
	beq	n106_detune_plus

n106_detune_minus:
	lda	detune_dat,x
	clc
	adc	sound_freq_low,x
	sta	sound_freq_low,x
	rts

n106_detune_plus:
	lda	detune_dat,x
	and	#%01111111
	sta	detune_tmp
	lda	sound_freq_low,x
	sec
	sbc	detune_tmp
	sta	sound_freq_low,x
	rts
;---------------------------------------------------------------
sound_n106_read:
	jsr	reg400x
	lda	[sound_add_low,x]
;----------
;f[^Ghݒ
	cmp	#$ff
	bne	n106_wave_set

	lda	loop_point_table,x
	sta	<sound_add_low,x
	inx
	lda	loop_point_table,x
	sta	<sound_add_low,x
	jmp	sound_n106_read
;----------
;Fݒ
n106_wave_set:
	cmp	#$fe
	bne	n106_volume_set
	jsr	sound_data_address
	lda	[sound_add_low,x]

	asl	a
	tax				;Ԗڂ̔g`g̐ݒJn

	lda	n106_wave_init,x	;;g`f[^[h
	asl	a
	asl	a
	sta	temporary

	lda	n106_wave_table,x
	sta	<n106_wave_add
	inx
	lda	n106_wave_table,x
	sta	<n106_wave_add_hi	;g`f[^JnAhXZbg

	lda	n106_wave_init,x	;g`f[^ItZbgAhX[h
	sta	n106_temp_2

	lda	#$7c
	jsr	n106_write_sub
	jsr	reg400x
	lda	temporary
	ora	#%11110000
	sta	n106_7c,x
	sta	$4800			;g`f[^Zbg
	lsr	temporary
	lda	#$10
	sec
	sbc	temporary
	sta	temporary		;g`f[^Zo

	lda	#$7e
	jsr	n106_write_sub
	lda	n106_temp_2
	sta	$4800			;g`f[^ItZbgAhXZbg

	lsr	a
	ora	#%10000000		;CNgI
	sta	$f800

	ldy	#$00
n106_wave_data_set:
	lda	[fds_wave_address],y
	sta	$4800			;g`݁iwave data write)
	iny
	cpy	temporary
	bmi	n106_wave_data_set

	jsr	reg400x
	jsr	sound_data_address
	jmp	sound_n106_read
;----------
;ʐݒ
n106_volume_set:
	cmp	#$fd
	bne	n106_rest_set
	jsr	sound_data_address
	lda	[sound_add_low,x]

	pha
	and	#%10000000		;bit7
	cmp	#%10000000
	bne	n106_softenve_part	;\tgGx

n106_volume_part:
	lda	effect_flag,x
	and	#%11111110
	sta	effect_flag,x		;\tgGxw

	pla
	and	#%00001111
	sta	n106_volume,x
	lda	#$7f

	jsr	n106_write_sub
	lda	n106_7f
	ora	n106_volume,x
	sta	$4800

	jsr	sound_data_address
	jmp	sound_n106_read

n106_softenve_part:
	lda	effect_flag,x
	ora	#%00000001
	sta	effect_flag,x		;\tgGxLw

	pla
	sta	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y	;\tgGxf[^AhXݒ
	sta	<soft_add_low,x
	iny
	lda	softenve_table,y
	sta	<soft_add_high,x
	jsr	sound_data_address
	jmp	sound_n106_read
;
;----------
n106_rest_set:
	cmp	#$fc
	bne	n106_lfo_set

	lda	rest_flag,x
	ora	#%00000001
	sta	rest_flag,x

	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x


	lda	#$7f
	jsr	n106_write_sub
	lda	n106_7f
	sta	$4800

	jsr	sound_data_address
	rts
;----------

n106_lfo_set:
	cmp	#$fb
	bne	n106_detune_set

	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	n106_lfo_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%10001111		;LFO
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_n106_read

n106_lfo_data_set:
	asl	a
	asl	a
	tay

	lda	channel_sel
	asl	a
	tax

	lda	lfo_data,y
	sta	lfo_st_counter_1,x
	sta	lfo_st_counter_2,x	;LFOJn܂ł̃JE^Zbg
	iny
	lda	lfo_data,y
	sta	lfo_move,x		;LFOœʃZbg
	iny
	lda	lfo_data,y
	sta	lfo_revers,x		;g`]܂ł̓񐔃Zbg
	inc	lfo_revers,x
	iny
	lda	effect_flag,x
	and	#%10001111
	ora	#%00010000		;LFOLtOZbg
	ora	lfo_data,y		;LFOJntOZbg
	sta	effect_flag,x

	jsr	sound_data_address
	jmp	sound_n106_read
;----------
n106_detune_set:
	cmp	#$fa
	bne	n106_pitch_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	n106_detune_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%01111111		;detune
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_n106_read

n106_detune_data_set:
	pha
	jsr	reg400x
	pla
	tay
	sta	detune_dat,x
	lda	effect_flag,x
	ora	#%10000000		;detuneL
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_n106_read

;----------
;sb`Gx[vݒ
n106_pitch_set:
	cmp	#$f8
	bne	n106_arpeggio_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	n106_pitch_enve_part

	lda	effect_flag,x
	and	#%11111101
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_n106_read

n106_pitch_enve_part:
	sta	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_table,y
	sta	<pitch_add_high,x

	lda	effect_flag,x
	ora	#%00000010
	sta	effect_flag,x

	jsr	sound_data_address
	jmp	sound_n106_read

;----------
;m[gGx[vݒ
n106_arpeggio_set:
	cmp	#$f7
	bne	n106_freq_direct_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	n106_arpeggio_part

	lda	effect_flag,x
	and	#%11110111
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_n106_read

n106_arpeggio_part:
	sta	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_table,y
	sta	<arpe_add_high,x

	lda	effect_flag,x
	ora	#%00001000
	sta	effect_flag,x
	jsr	sound_data_address
	jmp	sound_n106_read
;----------
;Đgڐݒ
n106_freq_direct_set:
	cmp	#$f6
	bne	n106_y_command_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_freq_low,x		;Low
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_freq_high,x		;High
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x			;Counter
	jsr	sound_data_address
	rts
;----------
;R}hݒ
n106_y_command_set:
	cmp	#$f5
	bne	n106_wait_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<reg_add_low
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<reg_add_high
	jsr	sound_data_address
	lda	[sound_add_low,x]
	ldx	#$00
	sta	[reg_add_low,x]
	jsr	reg400x
	jsr	sound_data_address
	jmp	sound_n106_read
;----------
;EFCgݒ
n106_wait_set:
	cmp	#$f4
	bne	n106_oto_set
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x
	jsr	sound_data_address
	rts
;----------
n106_oto_set:
	sta	sound_sel,x		;͂܂
	jsr	sound_data_address
	lda	[sound_add_low,x]	;ǂݏo
	sta	sound_counter,x		;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	jsr	n106_freq_set		;gZbg
;???
	lda	#$7f
	jsr	n106_write_sub
	lda	n106_7f
	ora	n106_volume,x
	sta	$4800

	jsr	n106_effect_init
	rts
;-------------------------------------------------------------------------------
sound_n106_write:
	jsr	reg400x

	lda	#$78
	jsr	n106_write_sub
	lda	sound_freq_low,x
	sta	$4800

	lda	#$7a
	jsr	n106_write_sub
	lda	sound_freq_mid,x
	sta	$4800

	lda	#$7c
	jsr	n106_write_sub
	lda	n106_7c,x
	ora	sound_freq_high,x
	sta	$4800

	rts
;-------------------------------------------------------------------------------
n106_write_sub:
	pha
	lda	channel_sel
	sta	$05
	sec
	sbc	#$05
	sta	n106_temp
	ldy	#$01
	pla
n106_roop:				;channel set
	cpy	n106_temp
	beq	n106_roop_end
	sec
	sbc	#$08
	iny
	jmp	n106_roop
n106_roop_end:
	sta	$f800
	rts
;-----------------------------------------------------
sound_n106_softenve:
	jsr	reg400x
	lda	[soft_add_low,x]
	cmp	#$ff
	beq	return2230
	sta	temporary
	lda	#$7f
	jsr	n106_write_sub
	lda	n106_7f
	ora	temporary
	sta	$4800
	jsr	enverope_address
	rts
return2230:
	lda	softenve_sel,x
	asl	a
	tay
	lda	softenve_lp_table,y
	sta	<soft_add_low,x
	iny
	lda	softenve_lp_table,y
	sta	<soft_add_high,x
	jmp	sound_n106_softenve
;-------------------------------------------------------------------------------
sound_n106_hard_enve:
	rts					;Ă悢
;-------------------------------------------------------------------------------
sound_n106_lfo:
	jsr	reg400x
	dec	lfo_st_counter_2,x
	bne	n106_lfo_end

	inc	lfo_st_counter_2,x

	lda	lfo_counter,x
	cmp	lfo_revers,x
	bne	n106_tsuduki		;@@ALFOύXJE^ >= g`]܂ł̓񐔁@ȂA

	lda	#$00
	sta	lfo_counter,x		;@@@@LFOύXJE^ = - g`]܂ł̓
	lda	effect_flag,x
	and	#%00100000
	cmp	#%00100000
	beq	n106_jousyou		;@@@@ALFOtO = ~ȂA

n106_kakou:
	lda	effect_flag,x
	adc	#$20
	sta	effect_flag,x		;@@@@@@LFOtO = ~
	jmp	n106_tsuduki

n106_jousyou:
	lda	effect_flag,x		;@@@@łȂȂiLFOtO = ~jȂA
	sbc	#$20
	sta	effect_flag,x		;@@@@@@LFOtO = ㏸


n106_tsuduki:
	lda	effect_flag,x		;   LFOtO = ~ Ȃ
	and	#%00100000
	cmp	#%00100000
	beq	n106_MINUS
					;ݐϒl = ݐϒl + P񂲂Ƃɑl
					;݂̒l = Kigj + ݐϒl
					;݂̒l = Kigj + (ݐϒl >> 4)
n106_PLUS:
	clc
	lda	sound_freq_low,x
	adc	lfo_move,x
	bcs	n106_freq_high_plus2
	sta	sound_freq_low,x	;    ݂̒l = ݂̒l - œl
	jmp	n106_tsuduki2
n106_freq_high_plus2:
	sta	sound_freq_low,x
	inc	sound_freq_high,x
	jmp	n106_tsuduki2

n106_MINUS:
	sec
	lda	sound_freq_low,x	;  łȂȂiLFOtO = ㏸łȂj
	sbc	lfo_move,x
	bcc	n106_freq_high_minus2
	sta	sound_freq_low,x	;    ݂̒l = ݂̒l + œl
	jmp	n106_tsuduki2
n106_freq_high_minus2:
	sta	sound_freq_low,x
	dec	sound_freq_high,x
					;܂ŁB
n106_tsuduki2:
	inc	lfo_counter,x		;	@@LFOύXJE^ = LFOύXJE^ + 1
	jsr	reg400x
	lda	sound_freq_low,x
	sta	$4082			;@@ݒlWX^ɃZbg
	lda	sound_freq_high,x
	sta	$4083
n106_lfo_end:
	rts				;܂
;-------------------------------------------------------------------------------
sound_n106_pitch_enve:
	jsr	reg400x			;XYreg𐮂
	lda	[pitch_add_low,x]	;sb`f[^ǂݏo
	cmp	#$ff			;I肩H
	beq	return2620		;IĂ჋[v

	and	#%10000000		;{|f
	cmp	#%10000000		;bit7mF
	beq	n106_pitch_plus		;bit7Ă΃}CiX

	lda	[pitch_add_low,x]	;phaplaőpĂǂ
	clc				;vẐ߃L[tONA
	adc	sound_freq_low,x	;Pɑ
	bcs	n106_freq_high_plus	;I[o[t[Ȃhigh{P
	sta	sound_freq_low,x	;low
	jmp	n106_pitch_write		;WX^݂GO!
n106_freq_high_plus:
	sta	sound_freq_low,x	;low
	inc	sound_freq_high,x	;high{P
	jmp	n106_pitch_write	;WX^݂GO!

n106_pitch_plus:			;zg̓}CiX
	lda	[pitch_add_low,x]	;sb`f[^ǂ݂
	and	#%01111111		;bit7
	sta	temporary		;e|ɕۑ
	sec				;L[tOZbg
	lda	sound_freq_low,x	;݂̒lǂݏo
	sbc	temporary		;sb`f[^}CiXvZ

	bcc	n106_freq_high_minus	;ʂĂ猅
	sta	sound_freq_low,x
	jmp	n106_pitch_write

n106_freq_high_minus:
	sta	sound_freq_low,x
	dec	sound_freq_high,x

n106_pitch_write:
	clv
	lda	sound_freq_low,x
	sta	$4082
	lda	sound_freq_high,x
	sta	$4083
	jsr	pitch_enverope_address
	rts

return2620:
	lda	[pitch_add_low,x]
	lda	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_lp_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_lp_table,y
	sta	<pitch_add_high,x
	jmp	sound_n106_pitch_enve
;-------------------------------------------------------------------------------
sound_n106_note_enve
	jsr	reg400x
	lda	[arpe_add_low,x]	;m[gGxf[^ǂݏo
	cmp	#$ff			;$ffiIjH
	bne	n106_tsuduki99		;łȂΑ
	jmp	n106_return82		;$ffȂ烋[v|Cg֖߂

n106_tsuduki99
	cmp	$00			;[H
	beq	n106_note_freq_write	;[Ȃ牽I
	cmp	$80
	beq	n106_note_freq_write	;[Ȃ牽I
	and	#%10000000
	cmp	#%10000000		;|H
	beq	n106_arpeggio_minus	;|

n106_arpeggio_plus:
	lda	[arpe_add_low,x]	;m[gGxf[^ǂݏo
	sta	arpeggio_tmp		;e|ɒui[v񐔁j
n106_arpeggio_plus2:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$0f			;4bito
	cmp	#$0b			;bȂ
	beq	n106_oct_plus		;IN^[u{
	inc	sound_sel,x		;łȂΉK{P
	jmp	n106_loop_1			;[vP
n106_oct_plus:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$f0			;4bito4bit[
	clc
	adc	#$10			;IN^[u{P
	sta	sound_sel,x		;Kf[^o
n106_loop_1:
	dec	arpeggio_tmp		;[v񐔁|P
	lda	arpeggio_tmp		;œǂݏo
	cmp	#$00			;[H
	beq	n106_note_freq_set	;Ȃ烋[vI
	jmp	n106_arpeggio_plus2	;łȂ΂܂

n106_arpeggio_minus:
	lda	[arpe_add_low,x]
	and	#%01111111
	sta	arpeggio_tmp
n106_arpeggio_minus2:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$0f			;4bito
	cmp	#$00			;[H
	beq	n106_oct_minus		;[Ȃ|
	dec	sound_sel,x		;łȂΉK|P
	jmp	n106_loop_2		;[vQ
n106_oct_minus:
	clc
	lda	sound_sel,x		;Kf[^ǂݏo
	adc	#$0b			;+b
	sec
	sbc	#$10			;-10
	sta	sound_sel,x		;Kf[^o
n106_loop_2:
	dec	arpeggio_tmp		;[v񐔁|P
	lda	arpeggio_tmp		;œǂݏo
	cmp	#$00			;[H
	beq	n106_note_freq_set	;Ȃ烋[vI
	jmp	n106_arpeggio_minus2	;łȂ΂܂

n106_note_freq_set:
	jsr	n106_freq_set
n106_note_freq_write:
	jsr	reg400x
	lda	sound_freq_low,x
	sta	$4082
	lda	sound_freq_high,x
	sta	$4083
	jsr	arpeggio_address
	rts

n106_return82:
	lda	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_lp_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_lp_table,y
	sta	<arpe_add_high,x
	jmp	sound_n106_note_enve
;-------------------------------------------------------------------------------
n106_effect_init:
;\tgEFAGx[vǂݍ݃AhX
	lda	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y
	sta	<soft_add_low,x
	iny
	lda	softenve_table,y
	sta	<soft_add_high,x

;sb`Gx[vǂݍ݃AhX
	lda	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	<pitch_add_low,x
	iny
	lda	pitchenve_table,y
	sta	<pitch_add_high,x

;m[gGx[vǂݍ݃AhX
	lda	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_table,y
	sta	<arpe_add_low,x
	iny
	lda	arpeggio_table,y
	sta	<arpe_add_high,x
;\tgEFALFO
	lda	lfo_st_counter_1,x	;LFOJnJE^Zbg
	sta	lfo_st_counter_2,x

	lda	effect_flag,x		;LFOJnZbg
	and	#%11011111
	sta	effect_flag,x
	and	#%01000000
	lsr	a
	ora	effect_flag,x
	sta	effect_flag,x
	lda	lfo_revers,x
	lsr	a
	sta	lfo_counter,x		;LFOύXJE^Zbg

;xtONA
	lda	#$00
	sta	rest_flag,x

	jsr	reg400x
	rts
;-------------------------------------------------------------------------------
